// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI6C500K/24DSI6C500K_1.x.x.x_GSC_DN/include/24dsi6c500k_utils.h $
// $Rev: 54777 $
// $Date: 2024-07-08 07:29:09 -0500 (Mon, 08 Jul 2024) $

// 24DSI6C500K: Utilities: header file

#ifndef	__24DSI6C500K_UTILS_H__
#define	__24DSI6C500K_UTILS_H__

#include "24dsi6c500k_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	dsi6c500k_close_util		(int fd, int index, int verbose);
int dsi6c500k_init_util			(int verbose);
int dsi6c500k_ioctl_util		(int fd, int index, int verbose, int request, void* arg);
int	dsi6c500k_open_util			(int device, int share, int index, int verbose, int* fd);
int	dsi6c500k_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);

// IOCTL utility services

int	dsi6c500k_ai_buf_clear		(int fd, int index, int verbose);								// DSI6C500K_IOCTL_AI_BUF_CLEAR
int	dsi6c500k_ai_buf_enable		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_AI_BUF_ENABLE
int	dsi6c500k_ai_buf_fill_lvl	(int fd, int index, int verbose, s32* get);						// DSI6C500K_IOCTL_AI_BUF_FILL_LVL
int	dsi6c500k_ai_buf_overflow	(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_AI_BUF_OVERFLOW
int	dsi6c500k_ai_buf_thr_sts	(int fd, int index, int verbose, s32* get);						// DSI6C500K_IOCTL_AI_BUF_THR_STS
int	dsi6c500k_ai_buf_thresh		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_AI_BUF_THRESH
int	dsi6c500k_ai_buf_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_AI_BUF_UNDERFLOW
int	dsi6c500k_ai_channel_tag	(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_AI_CHANNEL_TAG
int	dsi6c500k_ai_mode			(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_AI_MODE
int	dsi6c500k_autocal			(int fd, int index, int verbose);								// DSI6C500K_IOCTL_AUTOCAL
int	dsi6c500k_autocal_sts		(int fd, int index, int verbose, s32* get);						// DSI6C500K_IOCTL_AUTOCAL_STS
int	dsi6c500k_burst				(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_BURST
int	dsi6c500k_burst_rate_div	(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_BURST_RATE_DIV
int	dsi6c500k_burst_size		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_BURST_SIZE
int	dsi6c500k_burst_timer		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_BURST_TIMER
int	dsi6c500k_burst_trigger		(int fd, int index, int verbose);								// DSI6C500K_IOCTL_BURST_TRIGGER
int	dsi6c500k_ch_grp_0_src		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_CH_GRP_0_SRC
int	dsi6c500k_ch_grp_1_src		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_CH_GRP_1_SRC
int	dsi6c500k_channels_ready	(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_CHANNELS_READY
int	dsi6c500k_control_mode		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_CONTROL_MODE
int	dsi6c500k_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_DATA_FORMAT
int	dsi6c500k_data_width		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_DATA_WIDTH
int	dsi6c500k_dio_dir_out		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_DIO_DIR_OUT
int	dsi6c500k_dio_read			(int fd, int index, int verbose, s32* get);						// DSI6C500K_IOCTL_DIO_READ
int	dsi6c500k_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_DIO_WRITE
int	dsi6c500k_ext_clk_src		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_EXT_CLK_SRC
int	dsi6c500k_initialize		(int fd, int index, int verbose);								// DSI6C500K_IOCTL_INITIALIZE
int	dsi6c500k_irq_sel			(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_IRQ_SEL
int	dsi6c500k_ndiv				(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_NDIV
int	dsi6c500k_nref				(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_NREF
int	dsi6c500k_nvco				(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_NVCO
int	dsi6c500k_osr				(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_OSR
int	dsi6c500k_query				(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_QUERY
int	dsi6c500k_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// DSI6C500K_IOCTL_REG_MOD
int	dsi6c500k_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// DSI6C500K_IOCTL_REG_READ
int	dsi6c500k_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// DSI6C500K_IOCTL_REG_WRITE
int	dsi6c500k_rx_io_abort		(int fd, int index, int verbose, s32* get);						// DSI6C500K_IOCTL_RX_IO_ABORT
int	dsi6c500k_rx_io_mode		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_RX_IO_MODE
int	dsi6c500k_rx_io_overflow	(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_RX_IO_OVERFLOW
int	dsi6c500k_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_RX_IO_TIMEOUT
int	dsi6c500k_rx_io_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_RX_IO_UNDERFLOW
int	dsi6c500k_sw_sync			(int fd, int index, int verbose);								// DSI6C500K_IOCTL_SW_SYNC
int	dsi6c500k_sw_sync_mode		(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_SW_SYNC_MODE
int	dsi6c500k_sync_src			(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_SYNC_SRC
int	dsi6c500k_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI6C500K_IOCTL_WAIT_CANCEL
int	dsi6c500k_wait_event		(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI6C500K_IOCTL_WAIT_EVENT
int	dsi6c500k_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// DSI6C500K_IOCTL_WAIT_STATUS
int	dsi6c500k_xcvr_type			(int fd, int index, int verbose, s32 set, s32* get);			// DSI6C500K_IOCTL_XCVR_TYPE

// Auxiliary utility services

int	dsi6c500k_channel_group			(int fd, int index, int verbose, s32 channel, s32* group);
int	dsi6c500k_config_ai				(int fd, int index, int verbose, s32 fref, s32 fsamp);
int	dsi6c500k_fsamp_ai_compute		(int fd, int index, int verbose, s32 fref, s32 fsamp, s32* nvco, s32* nref, s32* ndiv, s32* osr, double* rate);
int	dsi6c500k_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int	dsi6c500k_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int	dsi6c500k_fsamp_ai_validate		(int fd, int index, int verbose, s32* fsamp);
int	dsi6c500k_id_device				(int fd, int index, int verbose);

int	dsi6c500k_count_boards		(int verbose, s32* get);
int	dsi6c500k_reg_list			(int fd, int detail);

const gsc_reg_def_t*			dsi6c500k_reg_get_def_id		(u32 reg);
const gsc_reg_def_t*			dsi6c500k_reg_get_def_index		(int index);
const char*						dsi6c500k_reg_get_desc			(u32 reg);
const char*						dsi6c500k_reg_get_name			(u32 reg);

// These are retained for backwards compatibility.
int	dsi6c500k_auto_cal_sts		(int fd, int index, int verbose, s32* get);
int	dsi6c500k_auto_calibrate	(int fd, int index, int verbose);


#endif


