// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI6C500K/24DSI6C500K_1.x.x.x_GSC_DN/utils/util_ai_buf_fill_lvl.c $
// $Rev: 49323 $
// $Date: 2021-05-20 18:31:54 -0500 (Thu, 20 May 2021) $

// 24DSI6C500K: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi6c500k_ai_buf_fill_lvl
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI6C500K_IOCTL_AI_BUF_FILL_LVL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi6c500k_ai_buf_fill_lvl(int fd, int index, int verbose, s32* get)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("AI Buffer Fill Level", index);

	ret		= dsi6c500k_ioctl(fd, DSI6C500K_IOCTL_AI_BUF_FILL_LVL, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");

		if ((set > 0) && ((set % 1024) == 0))
		{
			printf("%dK Sample%s", set / 1024, (set == 1024) ? "" : "s");
		}
		else
		{
			gsc_label_long_comma(set);
			printf(" Sample%s", (set == 1) ? "" : "s");
		}

		printf(")\n");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


