// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI6C500K/24DSI6C500K_1.x.x.x_GSC_DN/utils/util_channel_group.c $
// $Rev: 46781 $
// $Date: 2020-01-09 17:04:13 -0600 (Thu, 09 Jan 2020) $

// 24DSI6C500K: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi6c500k_channel_group
*
*	Purpose:
*
*		Report the channel group for the specified channel.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		chan	The channel index.
*
*		group	The channel's group index.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi6c500k_channel_group(int fd, int index, int verbose, s32 chan, s32* group)
{
	s32	chans;
	int	errs;

	group[0]	= 0;
	errs		= dsi6c500k_query(fd, -1, 0, DSI6C500K_QUERY_CHANNEL_QTY, &chans);

	if (errs)
	{
	}
	else if (chan < 0)
	{
		errs++;

		if (verbose)
		{
			printf(	"FAIL <---  (%d. invalid channel index: %ld, min is %ld)\n",
					__LINE__,
					(long) chan,
					(long) 0);
		}
	}
	else if (chan >= chans)
	{
		errs++;

		if (verbose)
		{
			printf(	"FAIL <---  (%d. invalid channel index: %ld, max is %ld)\n",
					__LINE__,
					(long) chan,
					(long) chans - 1);
		}
	}
	else
	{
		switch (chans)
		{
			default:

				errs++;

				if (verbose)
				{
					printf(	"FAIL <---  (%d. unexpected channel count: %ld)\n",
							__LINE__,
							(long) chans);
				}

				break;

			case 2:	group[0]	= (chan <= 0) ? 0 : 1;	break;
			case 4:	group[0]	= (chan <= 1) ? 0 : 1;	break;
			case 6:	group[0]	= (chan <= 2) ? 0 : 1;	break;
		}
	}

	return(errs);
}


