// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI6C500K/24DSI6C500K_1.x.x.x_GSC_DN/utils/util_dio_write.c $
// $Rev: 49323 $
// $Date: 2021-05-20 18:31:54 -0500 (Thu, 20 May 2021) $

// 24DSI6C500K: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi6c500k_dio_write
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI6C500K_IOCTL_DIO_WRITE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi6c500k_dio_write(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Digital I/O Write", index);

	ret		= dsi6c500k_ioctl(fd, DSI6C500K_IOCTL_DIO_WRITE, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%02lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


